

CREATE TABLE JOB
(job_id number(3),
Function Varchar(30));


create table employee
(employee_id number(4) ,
last_name varchar(15),first_name varchar(15),middle_initial varchar(1),hire_date date,
salary number(7,2),commission number(7,2),job_id number(3),department_id number(2));


create table customer
(customer_id number(6),
name varchar(45),address varchar(40),city varchar(30),state varchar(2),zip_code varchar(9),
area_code number(8),phone_number number(7),credit_limit number(9,2),comments long,salesperson_id number(4));
 
create table department
(department_id number(2),
nom varchar(14),location_id number(3)); 

create table location
(location_id number(3),
regional_group varchar(20));



create table sales_order 
(order_id number(4), 
order_date date, ship_date date, total number(8,2),customer_id number(6));



create table item
(item_id number(4),order_id number(4),  
actual_price number(8,2),quantity number(8),total number(8,2),product_id number(6));



create table product
(product_id number(6),description varchar(30));



create table price
(product_id number(6),start_date date, list_price number(8,2),min_price number(8,2),end_date date);



create table supplier
(supplier_id number(6),
name varchar(14),state_id  number(6),nombre number(6),street varchar(30),city varchar(30));



create table state
(state_id number(6),short_name varchar(6),long_name varchar(30));




create table supply
(supplier_id number(6),product_id number(6),  
price number(8,2));

alter table JOB add constraint PK_job primary key (job_id);
alter table employee add constraint PK_employee primary key (employee_id);
alter table customer add constraint PK_customer primary key (customer_id);
alter table department add constraint PK_department primary key (department_id);
alter table location add constraint PK_location primary key (location_id);
alter table sales_order add constraint PK_order_id primary key (order_id);
alter table item add constraint PK_item primary key (item_id,order_id);
alter table product add constraint PK_product primary key (product_id);
alter table price add constraint PK_price primary key (product_id,start_date);
alter table supplier add constraint PK_supplier primary key (supplier_id);
alter table state add constraint PK_state primary key (state_id );
alter table supply add constraint PK_supply primary key (supplier_id,product_id);





alter table department add constraint FK_department_location_location_id foreign key (location_id) references location(location_id);
alter table sales_order  add constraint FK_sales_order_customer_id foreign key (customer_id) references customer(customer_id);  
alter table item add constraint FK_item_order_id foreign key (order_id) references sales_order(order_id);
alter table item add constraint FK_item_product_id foreign key (product_id) references product(product_id);
alter table price add constraint FK_price_product_id foreign key (product_id) references product(product_id);
alter table supplier add constraint FK_supplier_state_id foreign key (state_id) references state(state_id);
alter table supply add constraint FK_supply_supplier_id foreign key (supplier_id) references supplier(supplier_id);
alter table supply add constraint FK_supply_product_id foreign key (product_id) references product(product_id);

create table erreur2_price(
  product_id number(6),
  oldmin number(8,2),
  newmin number(8,2),
  oldlist number(8,2),
  newlist number(8,2),
  action varchar2(30) 
  );


create or replace trigger verif_prix
before insert or delete or update
ON price
for each row
declare 
action varchar2(30);


BEGIN
  if :new.min_price > :new.list_price then
  raise_application_error('213','le prix mini est suprieur au prix max !!!');
  end if;

  if inserting then
  action :='insert';
  end if;
  


  insert into erreur2_price values(:new.product_id,
				:old.min_price,
				:new.min_price,
				:old.list_price,
				:new.list_price,
				action);

END;
/


insert into location values (122,'NEW YORK');
insert into location values (124,'DALLAS'); 
insert into location values (123,'CHICAGO');
insert into location values (167,'BOSTON');


insert into department values (10,'ACCOUNTING',122);
insert into department values (12,'RESEARCH',122);
insert into department values (13,'SALES',122);
insert into department values (14,'OPERATIONS',122);
insert into department values (20,'RESEARCH',124);
insert into department values (23,'SALES',124);
insert into department values (24,'OPERATIONS',124);
insert into department values (30,'SALES',123);
insert into department values (34,'OPERATIONS',123);
insert into department values (40,'OPERATIONS',167);
insert into department values (43,'SALES',167);



insert into job values (667,'CLERK');
insert into job values (668,'STAFF'); 
insert into job values (669,'ANALYST');
insert into job values (670,'SALESPERSON'); 
insert into job values (671,'MANAGER');
insert into job values (672,'PRESIDENT');
